zoukankan      html  css  js  c++  java
  • poj2151之概率DP

    Check the difficulty of problems
    Time Limit: 2000MS   Memory Limit: 65536K
    Total Submissions: 4403   Accepted: 1941

    Description

    Organizing a programming contest is not an easy job. To avoid making the problems too difficult, the organizer usually expect the contest result satisfy the following two terms: 
    1. All of the teams solve at least one problem. 
    2. The champion (One of those teams that solve the most problems) solves at least a certain number of problems. 

    Now the organizer has studied out the contest problems, and through the result of preliminary contest, the organizer can estimate the probability that a certain team can successfully solve a certain problem. 

    Given the number of contest problems M, the number of teams T, and the number of problems N that the organizer expect the champion solve at least. We also assume that team i solves problem j with the probability Pij (1 <= i <= T, 1<= j <= M). Well, can you calculate the probability that all of the teams solve at least one problem, and at the same time the champion team solves at least N problems?

     

    Input

    The input consists of several test cases. The first line of each test case contains three integers M (0 < M <= 30), T (1 < T <= 1000) and N (0 < N <= M). Each of the following T lines contains M floating-point numbers in the range of [0,1]. In these T lines, the j-th number in the i-th line is just Pij. A test case of M = T = N = 0 indicates the end of input, and should not be processed.

    Output

    For each test case, please output the answer in a separate line. The result should be rounded to three digits after the decimal point.

    Sample Input

    2 2 2
    0.9 0.9
    1 0.9
    0 0 0
    

    Sample Output

    0.972
    /*题意:
    ACM比赛中,共M道题,T个队,pij表示第i队解出第j题的概率
    问 每队至少解出一题且冠军队至少解出N道题的概率。

    分析: 对于须要求得概率比較easy想到: 如果p1为每一个队至少解出一题的概率,这个easy算出。 如果p2为每一个队至少解出一题可是不超过n-1题的概率 所以终于答案为:p1-p2 如今问题是怎样求出p2?

    如果dp[i][j]表示第i个队解出的题目<=j的概率 则dp[i][j]=解出1题+解出2题+...解出j题的概率 如今问题转化为怎样求解出1。2,3...k题的概率 如果x[i][j][k]表示第i个队在前j题解出k题的概率 则: x[i][j][k]=x[i][j-1][k-1]*p[i][j]+x[i][j-1][k]*(1-p[i][j]); 所以x[i][M][k]表示的就是第i个队解出k题的概率 */ #include <iostream> #include <cstdio> #include <cstdlib> #include <cstring> #include <string> #include <queue> #include <algorithm> #include <map> #include <cmath> #include <iomanip> #define INF 99999999 typedef long long LL; using namespace std; const int MAX=1000+10; const int N=30+10; int m,t,n,index; double x[2][N],dp,p[MAX][N]; int main(){ while(cin>>m>>t>>n,m+t+n){ double p1=1,p2=1,temp=1; for(int i=1;i<=t;++i){ temp=1; for(int j=1;j<=m;++j){cin>>p[i][j];temp=temp*(1-p[i][j]);} p1=p1*(1-temp);//1-temp表示至少解出一道题 } for(int i=1;i<=t;++i){ index=0; memset(x,0,sizeof x);//初始化前0个解出1~m为0 x[0][0]=1;//前0个解出0个为1 for(int j=1;j<=m;++j){ index=index^1; for(int k=1;k<=m;++k){ x[index][k]=p[i][j]*x[index^1][k-1]+(1-p[i][j])*x[index^1][k]; } x[index][0]=x[index^1][0]*(1-p[i][j]);//表示前j道题做出0题的概率 } dp=0;//dp表示第i队解出题目为1~n-1的概率 for(int j=1;j<=n-1;++j)dp+=x[index][j]; p2=p2*dp;//p2表示解出1~n-1题的概率 } printf("%.3f ",p1-p2); } return 0; }




  • 相关阅读:
    调度器2—cat /proc/<pid>/sched内容分析
    调度器1—相关接口和命令行工具
    Java中的String类
    Java中的数组
    代码访问使用Let's Encrypt证书的网站提示certificate has expired的解决方法
    Linux环境Clion使用Protobuf
    PyTorch Dataloader读取时如何在进程之间传输数据
    6 安装Grafana 展示promethues数据
    5 Prometheus relabel配置
    4 PromQL
  • 原文地址:https://www.cnblogs.com/zhchoutai/p/7217349.html
Copyright © 2011-2022 走看看